function adc_performance(NumBits, Fs, Fin, FundaBins, ADCData, useWindow)

NumHrmExc = 9;
NumHrms = 100;
NumSamples = length(ADCData);

fs = Fs * 1e6;
fin = Fin * 1e6;

% _________________________________________________________________________

% from frame 1 of labview code
ADCData_efflen = NumSamples;
PF_frm1_t = [1:ADCData_efflen/8];
PF_frm1_sin = round((sin(2*pi*(8/Fs)*Fin*PF_frm1_t) + 1)/2 * (2^NumBits - 1));
PF_frm1_fft = (abs(fft(PF_frm1_sin))/length(PF_frm1_sin)).^2;
PF_frm1_fft_db = 10 * log10(PF_frm1_fft(2:length(PF_frm1_fft)));

PF_frm1_out0 = abs((Fs/2 - Fin)/(Fs/ADCData_efflen));
PF_frm1_out1 = max(PF_frm1_fft_db);

% _________________________________________________________________________

% from frame 2_3 of labview code
PF_frm2_out0 = ADCData_efflen;
if(useWindow)
    w  = window(@blackmanharris,ADCData_efflen);
    PF_frm2_out1 = 20 * log10(abs(fft(ADCData(1:ADCData_efflen).*w))/ADCData_efflen);
else
    PF_frm2_out1 = 20 * log10(abs(fft(ADCData(1:ADCData_efflen)))/ADCData_efflen);
end

% _________________________________________________________________________

% from frame 3 of labview code
PF_frm3_out0 = PF_frm2_out1 - PF_frm1_out1;
PF_frm3_out1 = 0;
PF_frm3_d = PF_frm3_out0(1:ADCData_efflen/2);
PF_frm3_out2 = zeros(length(PF_frm3_d),1);
for i = 1:length(PF_frm3_d)
    PF_frm3_out2(i) = (i-1) * Fs/ADCData_efflen;
end
PF_frm3_d(1) = -160;
[max_PF_frm3_d max_PF_frm3_ind] = max(PF_frm3_d);
PF_frm3_tmp = (max_PF_frm3_ind - FundaBins);
if(PF_frm3_tmp > 1)
    PF_frm3_tmp2 = PF_frm3_d(PF_frm3_tmp-1);
else
    PF_frm3_tmp2 = PF_frm3_d(end);
end
PF_frm3_tmp3 = (FundaBins*2) + 1;
PF_frm3_tmp4 = 0;
for i = PF_frm3_tmp:(PF_frm3_tmp+PF_frm3_tmp3-1)
    if(i <= length(PF_frm3_d) && i > 1)
        PF_frm3_tmp4 = PF_frm3_tmp4 + 10^(PF_frm3_d(i)/10);
    end
end
PF_frm3_tmp6 = PF_frm3_tmp2 * ones(FundaBins,1);
PF_frm3_tmp5 = 10 * log10(PF_frm3_tmp4);
PF_frm3_tmp7 = [PF_frm3_tmp6; PF_frm3_tmp5; PF_frm3_tmp6];
PF_frm3_tmp7 = PF_frm3_tmp7(:);
PF_frm3_out3 = PF_frm3_d;
for i = 1:length(PF_frm3_tmp7)
    j = PF_frm3_tmp+i-1;
    if(j <= length(PF_frm3_d) && j > 1)
        PF_frm3_out3(j) = PF_frm3_tmp7(i);
    end
end

% _________________________________________________________________________

% from frame 4 of labview code

% ---- sub frame 0 --------------------------------------------------------

LocateHarmonics;
PF_frm4_0_tmp1 = AliasedHrmsBin(1:NumHrmExc);
PF_frm4_0_tmp2 = zeros(NumHrmExc,1);
PF_frm4_0_tmp3 = zeros(NumHrmExc,1);
for i=1:NumHrmExc
    PF_frm4_0_tmp2(i) = PF_frm3_out2(PF_frm4_0_tmp1(i) + 1);
    PF_frm4_0_tmp3(i) = PF_frm3_out3(PF_frm4_0_tmp1(i) + 1);
end
PF_frm4_out10 = PF_frm3_out1;

% ---- sub frame 1 --------------------------------------------------------

PF_frm4_1_tmp1 = AliasedHrmsBin(1);
PF_frm4_1_tmp2 = PF_frm3_out3(1:PF_frm4_1_tmp1);
PF_frm4_1_tmp3 = PF_frm3_out3(PF_frm4_1_tmp1+2:end);
PF_frm4_1_tmp4 = [PF_frm4_1_tmp2;PF_frm4_1_tmp3];
PF_frm4_1_out0 = PF_frm4_1_tmp4(2:end);
PF_frm4_1_tmp5 = PF_frm3_out3;
PF_frm4_1_tmp5(PF_frm4_1_tmp1+1) = -160;
[PF_frm4_out1 PF_frm4_1_out1] = max(PF_frm4_1_tmp5);
PF_frm4_1_out2 = (PF_frm3_out3(PF_frm4_1_tmp1+1));
PF_frm4_out0 = PF_frm4_1_out2 - PF_frm4_out1;
PF_frm4_1_out3 = PF_frm4_0_tmp3(1) ;  % BUG of labview code fixed!

% ---- sub frame 2 --------------------------------------------------------

PF_frm4_2_tmp1 = 10.^(PF_frm4_1_out0/10);
PF_frm4_2_tmp2 = sum(PF_frm4_2_tmp1);
PF_frm4_2_tmp3 = PF_frm4_2_tmp2/length(PF_frm4_2_tmp1);
PF_frm4_2_tmp4 = 10*log10((PF_frm4_2_tmp3 * 2) + PF_frm4_2_tmp2);
PF_frm4_2_out0 = 10*log10(PF_frm4_2_tmp3);
PF_frm4_out2 = PF_frm4_1_out3 - PF_frm4_2_tmp4;
PF_frm4_out3 = (PF_frm4_out2 - 1.76)/6.02;

% ---- sub frame 3 --------------------------------------------------------

PF_frm4_3_tmp1 = PF_frm3_out3;
for i = 1:NumHrmExc
    PF_frm4_3_tmp1(AliasedHrmsBin(i)+1) = PF_frm4_2_out0;
end
PF_frm4_3_tmp1(1) = PF_frm4_2_out0;
PF_frm4_3_tmp2 = 10.^(PF_frm4_3_tmp1/10);
PF_frm4_3_tmp3 = sum(PF_frm4_3_tmp2);
PF_frm4_3_tmp4 = PF_frm4_3_tmp3/length(PF_frm4_3_tmp1)*(NumHrmExc+1);
PF_frm4_3_tmp5 = 10*log10(PF_frm4_3_tmp3 + PF_frm4_3_tmp4);
PF_frm4_out4 = PF_frm4_1_out3 - PF_frm4_3_tmp5;
PF_frm4_out5 = (PF_frm4_out4 - 1.76)/6.02;
[PF_frm4_out6 PF_frm4_3_out0] = max(PF_frm4_3_tmp1);

% ---- sub frame 4 --------------------------------------------------------

PF_frm4_out7 = find(AliasedHrmsBin == (PF_frm4_3_out0 - 1));
PF_frm4_out8 = find(AliasedHrmsBin == (PF_frm4_1_out1 - 1));

% ---- sub frame 5 --------------------------------------------------------

PF_frm4_5_tmp1 = PwrHrms(1:NumHrmExc);
PF_frm4_5_tmp2 = PF_frm4_5_tmp1(2:end);
PF_frm4_out9 = PF_frm4_1_out2 - 10*log10(sum(10.^(PF_frm4_5_tmp2/10)));
Hrms_dBc = PF_frm4_1_out2 - PF_frm4_5_tmp1;

% _________________________________________________________________________

% Alternate Code to compute performance numbers
y = ADCData;
N = NumSamples;
s = abs(fft(y)/N*2);
s = s(1:N/2);
f = (0:length(s)-1) / N;
fx = fin;
fh = (2:(round(fs/fx/2)-1)) * fx;
while max(fh) > fs/2
    fh = abs(fh - fs*(fh > fs/2));
end
while fx > fs/2
    fx = abs(fx - fs*(fx > fs/2));
end
bx = round(N * fx/fs + 1);
fh(fh==fs/2) = 0;
bh = AliasedHrmsBin+1;
Asignal = s(bx);
sn = s;
sn(bx) = 1e-100;
sn(1) = 1e-100;
SFDR__ = 20*log10(Asignal/max(sn));
Aharm = sqrt(sum(sn(bh).^2));
sn(bh) = 1e-100;
Anoise = sqrt(sum(sn.^2));
SNR__ = 20*log10(Asignal/Anoise);
SNDR__ = 20*log10(Asignal/(Anoise+Aharm));
SDR__ = 20*log10(Asignal/Aharm);

% _________________________________________________________________________

Fin_array       = Fin;
SFDR            = PF_frm4_out0;
THD             = PF_frm4_out9;
SNR             = PF_frm4_out4;
SNDR            = PF_frm4_out2;
Ref             = PF_frm4_out10;
MaxSpur         = PF_frm4_out1;
enob            = PF_frm4_out5;
ENOB            = PF_frm4_out3;
MaxSNRSpur      = PF_frm4_out6;
MaxSNRSpurHn    = PF_frm4_out7;
MaxSpurHn       = PF_frm4_out8;
Hrms_dBc;

if(1)
    figure;
    xdata = PF_frm3_out2;
    ydata = PF_frm3_out3;
    I = find(ydata == -inf);
    ydata(I) = -160;
    plot(xdata,ydata);hold on;
    plot(PF_frm4_0_tmp2(1),PF_frm4_0_tmp3(1),'rd','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','r', 'MarkerSize',10);
    plot(PF_frm4_0_tmp2(2:end),PF_frm4_0_tmp3(2:end),'rd','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g', 'MarkerSize',10);hold off;
    text(PF_frm4_0_tmp2(1), PF_frm4_0_tmp3(1), sprintf('  A = %.1fdBFS', PF_frm4_0_tmp3(1)));
    for i=1:3
        text(PF_frm4_0_tmp2(i+1), PF_frm4_0_tmp3(i+1), sprintf('  H_{%d} = %.1fdBFS', i+1, PF_frm4_0_tmp3(i+1)));
    end
    xlabel('Frequency  [ MHz ]');
    ylabel('Amplitude  [ dBFS ]');
    axis([ 0 Fs/2 -130 10 ]);
    title(sprintf('N = %d    SNR = %.1fdBc   THD = %.1fdBc   SNDR = %.1fdBc   SFDR = %.1fdBc', NumSamples, SNR, THD, SNDR, SFDR));
    fixfig;
end

% _________________________________________________________________________
